#include <stdio.h>
#include <stdlib.h>

#include "liste.h"


/*!
************************************************
* \brief affiche une liste d'entier
* \param liste une liste d'entier
**************************************************/    
void afficherListe(LISTE liste)	
{char chaineAffichage[20]="|";
 ELEMLISTE *visitor;
 
 visitor=liste;
 while(visitor!=0)
   {
     fprintf(stdout,"|%d|",visitor->elem);
     visitor=visitor->suivant;
   }
 fprintf(stdout,"|--\n");
}	


/*!
************************************************
* \brief affiche une erreur et quite le programme 
* \warning Cette fonction interompt le programme
* \param message une chaîne de caractère 
**************************************************/    
int error1(char *message)	/*affiche l'erreur et sort*/
{
  fprintf(stderr,"Error: %s\n",message);
  exit(-1);
}


/*!
************************************************
* \brief Initialise une liste vide
* \return une liste vide
**************************************************/    
LISTE InitListe()	/*initialise une liste*/
{
LISTE liste1;

 liste1=(ELEMLISTE *)NULL;

  return(liste1);
}


/*!
************************************************
* \brief Ajoute un element au début d'une liste d'entier 
* \param  la liste 
* \param elem un entier a ajouter à la liste 
* \result La liste modifiée
* \return Modifie La liste, insère l'élément au début
* \return retourne 0 si il n'y a pas d'erreur
**************************************************/    
LISTE AjouterListe (LISTE liste, int elem)	
{ ELEMLISTE *newelem;  

 newelem=(ELEMLISTE *)malloc(sizeof(ELEMLISTE));
 if (newelem==0) error1("AjouterListe: plus de place mémoire");
 /* copier_valeur renvoie un pointeur vers un nouvel emplacement 
    memoire contenant la valeur pointée par elem */

 newelem->elem=elem;
 newelem->suivant=liste;
 return newelem;

 return(0);

}

/*!
************************************************
* \brief ajouter un element dans une liste triee
* \param pliste adresse d'une liste 
* \param val un entier a ajouter à la liste triee
* \warning On passe un pointeur sur une liste (donc un pointeur
*   sur un pointeur sur un element)
* \return Modifie La liste, insère l'élément inséré
* \return retourne 0 si il n'y a pas d'erreur
**************************************************/    
LISTE AjouterListeTrie (LISTE liste, int val)	
{ 
  ELEMLISTE *newelem;  
  LISTE finListe;
  
 // l'argument est un pointeur sur une liste ce qui permet de modifier
 // la liste (si l'élément est à insérer en première position par exemple)
 if (liste==NULL) 
   {
     // creation d'un nouvel element
     newelem=(ELEMLISTE *)malloc(sizeof(ELEMLISTE));
     if (newelem==0) error1("AjouterListeTrie: plus de place mémoire");
     newelem->elem=val;
     newelem->suivant=liste;
     //mise à jour de la liste
     return newelem;
   }
 else
   if ((liste)->elem > val)
     {//la valeur doit être insérée au début de la liste
       newelem=(ELEMLISTE *)malloc(sizeof(ELEMLISTE));
       if (newelem==0) error1("AjouterListeTrie: plus de place mémoire");
       newelem->elem=val;
       newelem->suivant=liste;
       return newelem;
     }
   else
     {// la valeur doit être insérée après le premier element
       finListe=liste->suivant;
       //appel recursif, finListe est modifiée par la procédure
       LISTE temp=AjouterListeTrie(finListe,val);
       //liste conserve son premier element
       liste->suivant=temp;
       liste;
     }
}


/*!
************************************************
* \brief retire un element en tête de liste
* \param pliste adresse d'une liste 
* \warning la fonction prend en argument un pointeur sur 
* \warning une liste puisqu'elle modifier la liste
* \return La valeur de l'élément retiré
* \return libère l'espace mémoire de l'élément
**************************************************/    
int RetirerListe(LISTE *pliste)	/*retirer le sommet de la liste*/
{
  ELEMLISTE *elem1;
  int val; 
  
  if (*pliste==NULL)
    error1("RetirerListe: liste vide");
  elem1=*pliste;
  val=elem1->elem;
  *pliste=elem1->suivant;
  free(elem1);
  return(val);
}


/*!
************************************************
* \brief vide une liste et libère l'espace mémoire 
* de tout ses éléments 
* \param pliste adresse d'une liste 
* \return O si il n'y a pas d'erreur
**************************************************/    
int ViderListe(LISTE *pliste)	/*vider la liste*/
{int counter,nbElem;
 ELEMLISTE *visitor,*temp;

 /* version itérative avec un visiteur */
 counter=0; 
 for(visitor=*pliste; visitor!=NULL; visitor=visitor->suivant)
   {
     temp=visitor;
     visitor=visitor->suivant;
     free(temp);
   }
 *pliste=(ELEMLISTE *)NULL;
 return(0);
}     


/*!
************************************************
* \brief fusion de deux listes triées,
* \param pliste1 adresse de la liste1 
* \param pliste2 adresse de la liste2 
* \return  la liste1 contient tous les éléments triés
* \return  la liste2 est vide
**************************************************/    
void fusion (LISTE *pliste1, LISTE *pliste2)	
{  LISTE   LL1, LL2;  

 if (*pliste2==NULL) 
   {//rien a faire
     return;
   }
 if (*pliste1==NULL) 
   {//list1<-list2
     *pliste1=*pliste2;
     *pliste2=(LISTE)NULL;
     return;
   }
 if ((*pliste1)->elem>(*pliste2)->elem)
   {//on insere un element de liste 2 dans liste1
     LL2=((*pliste2)->suivant);
     // appel recursif: on fusionne le reste dans liste1
     fusion(pliste1,&LL2);
     //*pliste1 est maintenant  la liste triée qui contient
     // tous les éléments sauf le premier de liste2
     // On met le 1er elt de liste2 au debut de liste1
     (*pliste2)->suivant=*pliste1;
     *pliste1=*pliste2;
     //mise a jour de liste2 (elle doit etre vide normalement)
     *pliste2=(LISTE)NULL;
   }
 else
   {//on laisse le premier element dans liste1
     LL1=((*pliste1)->suivant);
     // appel recursif: on fusionne le reste dans LL1
     fusion(&LL1,pliste2);
     //LL1 est maintenant la liste triée qui contient
     // tous les éléments sauf le premier de liste1
     (*pliste1)->suivant=LL1;
     //mise a jour de liste2 (elle doit etre vide normalement)
     *pliste2=(LISTE)NULL;
   }
 return;
}
     



